# -*- coding: utf-8 -*-
"""
Created on Sat Nov 10 17:52:33 2018

@author: Remy CHATEL 2411062C
"""
import numpy as np
import matplotlib.pyplot as pl

def plotting(filter_obj):
    """
    Print the impulse response of the given filter over 1000 taps
    """
    x = np.zeros(1000)
    x[10] = 1
    y = filter_obj.batch_filter(x)
    pl.subplots(2,1, figsize=(6.4*1.5,4.8*1.5))
    # pl.tight_layout(True)
    pl.subplot(2,1,1)
    pl.plot(y)
    pl.xlabel('Taps')
    pl.ylabel('Response amplitude')
    pl.title('Impulse response', loc='left')
    pl.subplot(2,1,2)
    pl.plot(np.linspace(0,1, len(y)), 20*np.log10(np.abs(np.fft.fft(y))))
    pl.xlabel('Normalised Frequencies')
    pl.ylabel('Amplitude (dB)')
    pl.title('Frequency response', loc='left')
    pl.suptitle('IIR Filter')
    return

class IIR2Filter:
    """
    A second order IIR filter
    """
    
    zeros = np.array([])
    poles = np.array([])
    buffer= np.array([0., 0.])
    
    def __init__(self, _zeros, _poles):
        """
        Constructor for the class IIR2Filter
        
        Parameters
        ----------
        _zeros : numpy array
            A two elements numpy array containing the zeros of the filter function
        _poles : numpy array
            A three elements numpy array containing the poles of the filter function
        """
        self.zeros = _zeros                             # Setting the zeros of the filter
        self.poles = _poles                             # Setting the poles of the filter
        self.buffer= np.array([0., 0.])                 # Creating the buffer
        return
    
    def filter(self, x):
        """
        Filters the input value with the second order IIR filter
        
        Parameters
        ----------
        x : float
            The input value
        
        Returns
        -------
        y : float
            The result of the filter
        """
        input_acc   = self.poles[0] * x                 # Adding new value to input buffer
        input_acc  -= self.poles[1] * self.buffer[0]    # First  IIR coefficient
        input_acc  -= self.poles[2] * self.buffer[1]    # Second IIR coefficient
        output_acc  = self.zeros[0] * input_acc         # Adding result to output buffer
        output_acc += self.zeros[1] * self.buffer[0]    # Second FIR coefficient
        output_acc += self.zeros[2] * self.buffer[1]    # Third  FIR coefficient
        
        self.buffer[1] = self.buffer[0]                 # Shifting data through buffer
        self.buffer[0] = input_acc
        
        return output_acc
    
    def batch_filter(self, X):
        """
        Filter an array in one pass
        
        Parameters
        ----------
        X : numpy array
            The input data
        
        Returns
        -------
        Y : numpy array
            The filtered data
        """
        Y = np.zeros(len(X))                            # Creating the output array
        for i in range(len(X)):                         # For each sample of the input
            Y[i] = self.filter(X[i])                    # filter the sample
        return Y
    
    def print(self, plot=True):
        print(' _____________________________________')
        print('|Second Order IIR filter :            |')
        print('|    %+1.3f %+1.3f*z^-1 %+1.3f*z^-2   |'% (self.zeros[0], self.zeros[1], self.zeros[2]))
        print('|    ------------------------------   |')
        print('|    %+1.3f %+1.3f*z^-1 %+1.3f*z^-2   |'% (self.poles[0], self.poles[1], self.poles[2]))
        print('|_____________________________________|')
        if plot:
            plotting(self)
        return

class IIRFilter:
    """
    A n-order IIR filter defined by a chain of second order IIR filter    
    """
    sos = np.array([])                                  # Second Order Section array
    order = 0                                           # Order of the filter
    chain = []                                          # List of 2nd order IIR filters
    
    def __init__(self, _sos):
        """
        Constructor of the class IIRFilter
        
        Parameters
        ----------
        sos : numpy array
            The Second Order Section of the filter as generated by high level function of
            scipy.signal module
        """
        self.sos = _sos                                 # Storing the sos coefficients
        self.order = len(_sos)                          # Computing filter's order
        
        for i in range(len(_sos)):                      #For every 2nd order filter of sos
            zeros, poles = _sos[i,:3], _sos[i,3:]       # Fetch the poles and zeros
            self.chain.append(IIR2Filter(zeros, poles)) # Append a 2nd order filter
        
        return
    
    def filter(self, x):
        """
        Filters the input value with the second order IIR filter
        
        Parameters
        ----------
        x : float
            The input value
        
        Returns
        -------
        y : float
            The result of the filter
        """
        y = self.chain[0].filter(x)                     # Filter value with first filter
        
        for i in range(1, len(self.chain)):             # For all other 2nd order filter
            y = self.chain[i].filter(y)                 # Filter the resulting value
        
        return y                                        # Return the value
    
    def batch_filter(self, X):
        """
        Filter an array in one pass
        
        Parameters
        ----------
        X : numpy array
            The input data
        
        Returns
        -------
        Y : numpy array
            The filtered data
        """
        Y = np.zeros(len(X))
        for i in range(len(X)):
            Y[i] = self.filter(X[i])
        return Y
    
    def print(self, plot=True):
        print(' _________________________________________')
        print('|IIR filter :                             |')
        print('|Order : %2d                               |'% self.order)
        for i in range(len(self.chain)):
            self.chain[i].print(plot=False)
        print('|_________________________________________|')
        if plot:
            plotting(self)
        return
        